﻿//Build VC++2019 ,文字セット:マルチ バイト文字セットを使用する
#include <Windows.h>
#include <vector>
#include <tlhelp32.h>
#include <string>
#include <sstream>
#include <Mmdeviceapi.h>
#include <locale>
#include <iostream>
#include <fstream>
#include <endpointvolume.h>
#include <codecvt>
#include <Audiopolicy.h>

// グローバル変数
HWND g_hWnd = NULL;
HWND hEdit = NULL;
std::wstring windowTitle;
std::wstring windowClass;
bool mute = false;
BOOL muteState = false;
BOOL WinmuteState = false;
int waitForProcessExit = 0;
int argIndex = 0;
int loadline = 0;
int IDC_EDIT;

//COMオブジェクト等初期化
ISimpleAudioVolume* sessionVolume = NULL;//セッションの音量調整用
IAudioEndpointVolume* endpointVolume = NULL;//Windowsの音量調整用
IMMDeviceEnumerator* pEnumerator = NULL;
IMMDevice* pDevice = NULL;
IAudioSessionManager2* pSessionManager = NULL;
IAudioSessionEnumerator* pSessionEnumerator = NULL;
IAudioSessionControl* pSessionControl = NULL;
IAudioSessionControl2* pSessionControl2 = NULL;

//サブスレッド
DWORD WINAPI WaitForProcessExitThread(LPVOID lpParam);

// プロセスIDからプロセスのハンドルを取得する関数
HANDLE GetProcessHandleFromProcessId(DWORD processId) {
	HANDLE hProcess = OpenProcess(SYNCHRONIZE, FALSE, processId);
	return hProcess;
}

// 呼び出し元プロセスのハンドルを取得する関数
HANDLE GetCallingProcessHandle() {
	HANDLE hProcess = NULL;
	DWORD currentProcessId = GetCurrentProcessId();
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	PROCESSENTRY32 processEntry;
	processEntry.dwSize = sizeof(PROCESSENTRY32);

	if (Process32First(hSnapshot, &processEntry)) {
		do {
			if (processEntry.th32ProcessID == currentProcessId) {
				hProcess = GetProcessHandleFromProcessId(processEntry.th32ParentProcessID);
				break;
			}
		} while (Process32Next(hSnapshot, &processEntry));
	}

	CloseHandle(hSnapshot);
	return hProcess;
}
LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{
		// エディットコントロールを作成し、初期テキストを設定
		hEdit = CreateWindowEx(
			0,
			"EDIT",
			"",
			WS_CHILD | WS_VISIBLE | WS_BORDER | ES_READONLY | ES_MULTILINE,
			0, 0, 535, 90,
			hWnd,
			(HMENU)IDC_EDIT,
			GetModuleHandle(NULL),
			NULL
		);
	}
	break;

	case WM_COMMAND:
	{
		// テキストボックス内のテキストの長さを取得
		hEdit = GetDlgItem(hWnd, IDC_EDIT);
		int textLength = GetWindowTextLengthW(hEdit);

		// テキストの長さが0でない場合に選択処理を実行
		if (textLength > 0) {
			// メッセージボックスを閉じる前にエディットボックスのテキストを全選択
			SetFocus(hEdit);
			SendMessageW(hEdit, EM_SETSEL, 0, -1);
		}
	}
	break;

	case WM_SIZE:
	{
		RECT clientRect;
		GetClientRect(hWnd, &clientRect);

		// クライアント領域の幅と高さを取得
		int clientWidth = clientRect.right - clientRect.left;
		int clientHeight = clientRect.bottom - clientRect.top;

		// ウィンドウのサイズを設定
		SetWindowPos(hEdit, NULL, 0, 0, clientWidth, clientHeight, SWP_NOMOVE | SWP_NOZORDER);

	}
	break;


	case WM_CLOSE:
		//COMオブジェクト操作中(ミュート待機操作中)に終了命令が出た場合
		if (waitForProcessExit != 2) {
			PostQuitMessage(0);
			break;
		}
		if (!WinmuteState && windowTitle == L"-1") {
			endpointVolume->SetMute(FALSE, NULL);
		}
		if (!muteState && windowTitle != L"-1") {
			//最初からミュートじゃない場合にミュート解除
			sessionVolume->SetMute(FALSE, NULL);
		}
		if (sessionVolume) { sessionVolume->Release(); sessionVolume = NULL; }
		if (endpointVolume) { endpointVolume->Release(); endpointVolume = NULL; }
		if (pSessionControl2) { pSessionControl2->Release(); pSessionControl2 = NULL; }
		if (pSessionControl) { pSessionControl->Release(); pSessionControl = NULL; }
		if (pSessionEnumerator) { pSessionEnumerator->Release(); pSessionEnumerator = NULL; }
		if (pSessionManager) { pSessionManager->Release(); pSessionManager = NULL; }
		CoUninitialize();
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

// メッセージを表示し、メッセージループにジャンプするサブルーチン
//void REMessage(const wchar_t* stdMessage) {
void REMessage(const std::basic_string<wchar_t>& stdMessage) {
	const wchar_t* message = stdMessage.c_str();
	// コンソールから起動された場合にメッセージをコンソールに出力
	if (AttachConsole(ATTACH_PARENT_PROCESS) && waitForProcessExit != 2) {
		// メッセージをコンソールに出力
		FILE* new_stdout;
		freopen_s(&new_stdout, "CONOUT$", "w", stdout);
		wprintf(L"\n%s", stdMessage);
		// コンソールをデタッチ
		FreeConsole();
		PostMessage(g_hWnd, WM_CLOSE, 0, 0);
		return;
	}
	else {
		//ウィンドウを通常表示
		ShowWindow(g_hWnd, SW_NORMAL);
		// エディットボックスを取得
		HWND hEdit = GetDlgItem(g_hWnd, IDC_EDIT); // IDC_EDIT はエディットボックスの識別子

		if (hEdit != NULL) {
			// メッセージをエディットボックスに表示
			SetWindowTextW(hEdit, message);
		}
	}
	FreeConsole();
}

void DisplayErrorMessage(const wchar_t* errorMessage = nullptr) {
	const wchar_t* usage = L"Usage: volume_mute.exe [/mute /unmute /list] [/l \<listNo.\>] [/w] \<WindowTitle\> [\"WindowClass\"]";
	std::wstring message;
	if (errorMessage != nullptr) {
		message = errorMessage;
	}
	message += L"\r\n";
	message += usage;
	REMessage(message.c_str());
}


//ウィンドウタイトルとクラスをテキストファイルから取得
bool ReadWindowTitleAndClassFromTextFile(const std::wstring& filePath, std::wstring& windowTitle, std::wstring& windowClass, int loadline) {

	std::wifstream file(filePath);
	file.imbue(std::locale(file.getloc(), new std::codecvt_utf8<wchar_t, 0x10ffff, std::consume_header>));

	if (file.is_open()) {
		std::wstring line;
		std::vector<std::wstring> tokens;
		int currentLine = 0;
		int nowline = 0;

		if (loadline == -1) {
			std::wstring message;
			while (std::getline(file, line)) {

				// 整数を文字列に変換
				std::wstringstream ss;
				ss << currentLine;
				std::wstring currentLineStr = ss.str();

				// メッセージを生成
				message += currentLineStr + L". " + line + L"\r\n";

				currentLine++;
			}
			// REMessageに渡す
			REMessage(message.c_str());
			return true;
		}

		while (std::getline(file, line, L'"')) {
			// データが改行コードの場合、ループから抜ける
			if (line == L"\n") {
				currentLine++;
				if (currentLine == loadline + 1) {
					break;
				}
				nowline = tokens.size();
			}
			tokens.push_back(line);
		}
		if (tokens[nowline + 1].size() >= 1 && currentLine >= loadline) {
			windowTitle = tokens[nowline + 1];
			if (tokens.size() > nowline + 3) {
				windowClass = tokens[nowline + 3];
			}
			else {
				windowClass = L""; // クラス名が指定されていない場合は空文字列を設定
			}
			return true;
		}
	}
	return false; // ファイルが開けないか、読み取りに失敗した場合は false を返す
}

//音量調整
void AdjustVolume(bool mute, bool muteState, bool WinmuteState, int& waitForProcessExit) {
	if (!mute) {
		if (windowTitle == L"-1") {
			endpointVolume->SetMute(FALSE, NULL);
		}
		else {
			sessionVolume->SetMute(FALSE, NULL);
		}
	}

	if (!muteState) {
		// ミュートに切り替えます
		if (!WinmuteState && windowTitle == L"-1") {
			endpointVolume->SetMute(mute, NULL);
		}
		else if (windowTitle != L"-1") {
			sessionVolume->SetMute(mute, NULL);
		}

		HANDLE hParentProcess = GetCallingProcessHandle();
		if (mute && waitForProcessExit && hParentProcess != NULL) {
			// 呼び出し元プロセスの終了を待機します
			waitForProcessExit = 2;
			REMessage(L"Waiting for caller process to exit...\r\n呼び出し元プロセスの終了を待っています...");
			WaitForSingleObject(hParentProcess, INFINITE);
		}
		hParentProcess = NULL;
	}
	PostMessage(g_hWnd, WM_CLOSE, 0, 0);
	return;
}

//ウィンドウメインスレッド
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow)
{

	LPWSTR* wargv;
	int argc;
	wargv = CommandLineToArgvW(lpCmdLine, &argc);

	// ウィンドウクラスの登録
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, WindowProc, 0L, 0L, GetModuleHandle(NULL), NULL, NULL, NULL, NULL, ("volume_mute_c"), NULL };
	RegisterClassEx(&wc);

	// ウィンドウを作成して表示
	g_hWnd = CreateWindow(wc.lpszClassName, ("Volume Mute"), WS_OVERLAPPEDWINDOW, 100, 100, 700, 128, GetDesktopWindow(), NULL, wc.hInstance, NULL);
	int s_Wnd = ShowWindow(g_hWnd, SW_MINIMIZE);

	switch (s_Wnd)
	{
	case 0:
	{

		if (argc == 0) {
			//CreateWindowExで作成したエディットボックスにメッセージを表示し、メッセージループにジャンプしてウィンドウを閉じないようにする。
			DisplayErrorMessage();
			break;
		}

		if (std::wstring(wargv[argIndex]) == L"/mute") {
			mute = true;
			argIndex++;
		}
		else if (std::wstring(wargv[argIndex]) == L"/unmute") {
			argIndex++;
		}
		else if (std::wstring(wargv[argIndex]) == L"/list") {
			argIndex++;
			loadline = -1;
		}
		else {
			DisplayErrorMessage(L"Invalid command");
			break;
		}

		if (argIndex < argc && std::wstring(wargv[argIndex]) == L"/l") {
			argIndex++;
			// wargv[x] を int に変換
			try {
				loadline = std::stoi(wargv[argIndex]);
				argIndex++;
			}
			catch (const std::exception& e) {
				DisplayErrorMessage(L"Invalid Number");
				break;
			}
		}

		if (argIndex < argc && std::wstring(wargv[argIndex]) == L"/w") {
			waitForProcessExit = 1;
			argIndex++;
		}

		if (argIndex >= argc) {
			DisplayErrorMessage(L"Missing window title");
			break;
		}

		// コマンドライン引数からウィンドウタイトルとクラスを取得
		windowTitle = wargv[argIndex];
		windowClass;

		if (argIndex + 1 < argc) {
			windowClass = wargv[argIndex];
		}

		// windowTitleに.txtが含まれている場合、.txtからウィンドウタイトルとクラスを取得
		if (windowTitle.rfind(L".txt") == windowTitle.length() - 4) {
			wchar_t currentDirectory[MAX_PATH];

			// カレントディレクトリのパスを取得
			DWORD length = GetCurrentDirectoryW(MAX_PATH, currentDirectory);
			std::wstring fullFilePath = std::wstring(currentDirectory) + L"\\" + windowTitle;
			ReadWindowTitleAndClassFromTextFile(fullFilePath, windowTitle, windowClass, loadline);
		}
		//リスト表示ではない場合
		if (loadline != -1) {
			DWORD threadId;
			HANDLE hThread = CreateThread(NULL, 0, WaitForProcessExitThread, NULL, 0, &threadId);
		}
	}
	default:
		break;
	}

	// メッセージループを開始
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

//COMサブスレッド
DWORD WINAPI WaitForProcessExitThread(LPVOID lpParam)
{
	HWND hWnd = NULL;
	if (!windowClass.empty()) {
		// ウィンドウクラスとタイトルからウィンドウハンドルを取得
		hWnd = FindWindowW(windowClass.c_str(), windowTitle.c_str());
	}
	else {
		// タイトルだけからウィンドウハンドルを取得
		hWnd = FindWindowW(NULL, windowTitle.c_str());
	}

	if (hWnd == NULL && windowTitle != L"-1") {
		DisplayErrorMessage(L"Window not found");
		return 1;
	}
	// スレッドごとにCOM ライブラリを初期化
	HRESULT hr = CoInitialize(NULL);
	if (FAILED(hr)) {
		// 初期化に失敗した場合の処理
		return 1;
	}

	DWORD targetPID;
	GetWindowThreadProcessId(hWnd, &targetPID);

	CoCreateInstance(
		__uuidof(MMDeviceEnumerator),
		NULL,
		CLSCTX_ALL,
		__uuidof(IMMDeviceEnumerator),
		(void**)&pEnumerator);

	pEnumerator->GetDefaultAudioEndpoint(eRender, eConsole, &pDevice);
	pEnumerator->Release();
	pEnumerator = NULL;

	int sessionCount = 0;
	if (windowTitle == L"-1") {
		//Windows自体のミュート
		pDevice->Activate(__uuidof(IAudioEndpointVolume), CLSCTX_INPROC_SERVER, NULL, (LPVOID*)&endpointVolume);
		pDevice->Release();
		endpointVolume->GetMute(&WinmuteState);
		AdjustVolume(mute, muteState, WinmuteState, waitForProcessExit);
	}
	else {
		//アプリケーション単体のミュート
		pDevice->Activate(
			__uuidof(IAudioSessionManager2),
			CLSCTX_ALL,
			NULL,
			(void**)&pSessionManager);
		pDevice->Release();
		pDevice = NULL;
		pSessionManager->GetSessionEnumerator(&pSessionEnumerator);
		pSessionEnumerator->GetCount(&sessionCount);
	}

	for (int i = 0; i < sessionCount; i++) {

		pSessionEnumerator->GetSession(i, &pSessionControl);
		pSessionControl->QueryInterface(__uuidof(IAudioSessionControl2), (void**)&pSessionControl2);

		DWORD sessionPID;
		pSessionControl2->GetProcessId(&sessionPID);

		if (sessionPID == targetPID) {
			// セッションの音量を制御します
			pSessionControl->QueryInterface(__uuidof(ISimpleAudioVolume), (LPVOID*)&sessionVolume);
			sessionVolume->GetMute(&muteState);
			AdjustVolume(mute, muteState, WinmuteState, waitForProcessExit);
			PostMessage(g_hWnd, WM_CLOSE, 0, 0);
		}
	}
}